#!/usr/bin/python -tt

import bz2
import glob
import gzip
import optparse
import re
import sys

import lzma

parser = optparse.OptionParser(usage='''search [options] pattern directory [directory [.. [directory]]]''')
parser.add_option('-i', dest='insensitive', action='store_true', help='Case insensitive search')
(opts, args) = parser.parse_args()
flags = 0
if opts.insensitive:
    flags = re.I
patternRE = re.compile(args[0], flags=flags)
directories = args[1:]

for directory in directories:
    for filename in glob.glob('%s/*' % directory):
        if filename.endswith('.gz'):
            logfile = gzip.GzipFile(filename)
        elif filename.endswith('.bz2'):
            logfile = bz2.BZ2File(filename)
        elif filename.endswith('.xz'):
            logfile = lzma.LZMAFile(filename)
        else:
            print 'I cannot unzip %s' % filename
            sys.exit(1)

        output = []
        for line in logfile:
            if patternRE.search(line):
                output.append(line.rstrip())
        if output:
            print '== %s ==' % filename
            print '\n'.join(output)
