#!/bin/sh

# Deal with command line args
getopt -oi -Q -- "$@"
if [ $? -ne 0 ] ; then
  echo 'search.sh [-i] PATTERN DIRECTORY [DIRECTORY [.. [DIRECTORY]]]'
  exit 1
fi

insensitive=
directories=
pattern=
for param ; do
  case $param in
    -i) insensitive='-i' ;;
    *)
      if [ -z "$pattern" ] ; then
        pattern="$param"
      else
        directories+=" $param"
      fi
      ;;
  esac
done
for directory in $directories ; do
  for filename in `ls "$directory"/log*` ; do
    case $filename in
        *.gz) UNZIP=zcat ;;
        *.bz2) UNZIP=bzcat ;;
        *.xz) UNZIP=xzcat ;;
        *) echo "I cannot unzip '$filename'" && exit 1 ;;
    esac
    output=`$UNZIP $filename | grep $insensitive "$pattern"`
    if [ -n "$output" ] ; then
       echo "== $filename =="
       echo $output
    fi
  done
done