#!/bin/sh

# Search all log files in the current directory
for filename in `ls log*` ; do
   # Register an uncompressor for them
   case $filename in
      *.gz) UNZIP=zcat ;;
      *.bz2) UNZIP=bzcat ;;
      *.xz) UNZIP=xzcat ;;
      *) echo "I cannot uncompress '$filename'" && exit 1 ;;
   esac
   # Uncompress and search for our pattern
   output=`$UNZIP $filename | grep 'toshio'`
   # If we found the pattern, print it to the screen
   if [ -n "$output" ] ; then
     echo "== $filename =="
     echo $output
   fi
done